﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using Infragistics;
using System.Collections.ObjectModel;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<string> lstColumns = new List<string>();

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = LoadData().DefaultView;
        }        

        private DataTable LoadData()
        {
            lstColumns.Add("CompanyName");
            lstColumns.Add("Ticker");
            lstColumns.Add("MicCode");
            lstColumns.Add("RegressionName");
            lstColumns.Add("Publisher");
            lstColumns.Add("Industry");
            lstColumns.Add("Multiple");
            lstColumns.Add("NumQtrsLead");
            lstColumns.Add("TimePeriod");
            lstColumns.Add("ModelCase");
            lstColumns.Add("RSquared");
            lstColumns.Add("IndicatorPercentile");
            lstColumns.Add("OverUnderValuation");
            
            int counter = 0;
            DataTable dt = new DataTable();
            foreach (var item in lstColumns)
            {
                if (counter <= 6)
                    dt.Columns.Add(item, typeof(string));
                else if (counter == 7)
                    dt.Columns.Add(item, typeof(int));
                else if (counter == 8)
                    dt.Columns.Add(item, typeof(DateTime));
                else if (counter == 9)
                    dt.Columns.Add(item, typeof(string));
                else
                    dt.Columns.Add(item, typeof(double));

                counter++;
            }

            dt.Columns.Add("OilWith1M", typeof(double));
            dt.Columns.Add("CapUtilPC", typeof(double));
            dt.Columns.Add("UnEmployement", typeof(double));
            dt.Columns.Add("NaturalGas", typeof(double));
            dt.Columns.Add("10YTreasury", typeof(double));
            dt.Columns.Add("USUnEmployemnet", typeof(double));
            dt.Columns.Add("IndustrialProduction", typeof(double));
            dt.Columns.Add("NewHomeSales", typeof(double));
            dt.Columns.Add("InventorySalesRatio", typeof(double));
            dt.Columns.Add("NaturalGasNYM", typeof(double));
            dt.Columns.Add("Dummy", typeof(double));           

            Random r = new Random();
            for (int i = 1; i < 20; i++)
            {
                DataRow row = dt.NewRow();
                counter = 0;

                foreach (var item in dt.Columns)
                {
                    if (counter <= 6)
                        row[item.ToString()] = Guid.NewGuid().ToString().Substring(0, 5);
                    else if (counter == 7)
                    {
                        if (i%2==0)
                        {
                            row[item.ToString()] = 0;
                        }
                        else
                            row[item.ToString()] = r.Next(1000 * i);
                    }
                        
                    else if (counter == 8)
                        row[item.ToString()] = DateTime.Now.AddDays(i);
                    else if (counter == 9)
                        row[item.ToString()] = Guid.NewGuid().ToString().Substring(0, 5);
                    else
                        row[item.ToString()] = r.Next(1000 * i);

                    counter++;
                }

                dt.Rows.Add(row);
            }

            return dt;
        }      

        private void xamGrid1_ColumnAutoGenerated(object sender, ColumnAutoGeneratedEventArgs e)
        {
            if (e.Column is TextColumn)
            {                
                (e.Column as TextColumn).FormatString = @"{0:#0.00\%}";

                if (e.Column.Key == "Dummy")
                    e.Column.Visibility = Visibility.Collapsed;

                int ColumnIndex = (sender as XamGrid).Columns.Count;
                if (ColumnIndex > 13)
                {
                    Column DisplaySummary = xamGrid1.Columns.DataColumns[ColumnIndex - 1];
                    DisplaySummary.SummaryColumnSettings.SummaryOperands.Clear();
                    AverageSummaryOperand avg = new AverageSummaryOperand();
                    avg.IsApplied = true;
                    avg.RowDisplayLabel = "Average ";
                    avg.FormatString = @"{0:#0.00\%}";
                    DisplaySummary.SummaryColumnSettings.SummaryOperands.Add(avg);
                    DisplaySummary.HorizontalContentAlignment = HorizontalAlignment.Left;
                }
            }
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            xamGrid1.SummaryRowSettings.AllowSummaryRow = SummaryRowLocation.Top;
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            xamGrid1.SummaryRowSettings.AllowSummaryRow =  SummaryRowLocation.None;
        }

        private void xamGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            this.xamGrid1.Columns.DataColumns["NumQtrsLead"].SummaryColumnSettings.SummaryOperands.Add(new StandardDeviationOperand());
            this.xamGrid1.Columns.DataColumns["CompanyName"].SummaryColumnSettings.SummaryOperands.Add(new AverrageTextOperand());
        }

        private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if ((sender as ComboBox).SelectedIndex == 0)
            {
                foreach (var item in xamGrid1.SummaryRowSettings.SummaryDefinitionCollection)
                {
                    item.SummaryOperand.FormatString = "{0:P2}";
                }
            }
            else
                foreach (var item in xamGrid1.SummaryRowSettings.SummaryDefinitionCollection)
                {
                    item.SummaryOperand.FormatString = "{0}";
                }
        }


        //public DataTable CreateTable(int columns, int rows)
        //{
        //    DataTable d = new DataTable();
        //    Random r = new Random();

        //    for (int i = 0; i < columns; i++)
        //    {
        //        d.Columns.Add(new DataColumn("Column " + i, typeof(int)));
        //    }
        //    for (int i = 0; i < rows; i++)
        //    {
        //        DataRow row = d.NewRow();

        //        for (int j = 0; j < columns; j++)
        //        {
        //            row["Column " + j] = r.Next(1, 5);
        //        }

        //        d.Rows.Add(row);
        //    }
        //    return d;
        //}        
    }

    public class ColumnNameConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value.ToString() == "Column 0")
            {
                return "My Column 0 ";
            }
            if (value.ToString() == "Column 2")
            {
                return "My Column 2 ";
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class StandardDeviationCalc : SynchronousSummaryCalculator
    {
        public override SummaryExecution? SummaryExecution
        {
            get
            {
                return Infragistics.SummaryExecution.PriorToFilteringAndPaging;
            }
        }

        public override object Summarize(IQueryable data, string fieldKey)
        {
            IQueryable<DataRowView> convertedData = (IQueryable<DataRowView>)data;

            // Variables used for intermediate calculations
            double sum = 0;
            int zeroCount = 0;
            double tempVal = 0;

            foreach (DataRowView item in convertedData)
            {
                // Value in UnitsInStock column
                tempVal = Convert.ToDouble(item["NumQtrsLead"]);
                if (tempVal == 0)
                {
                    zeroCount++;
                }

                sum += tempVal;
            }

            return sum /( convertedData.Count() - zeroCount);
        }
    }

    public class StandardDeviationOperand : SummaryOperandBase
    {
        StandardDeviationCalc myCalc;

        protected override string DefaultRowDisplayLabel
        {
            get { return ""; }
        }

        protected override string DefaultSelectionDisplayLabel
        {
            get { return "My Avarage Menu Text"; }
        }

        public override SummaryCalculatorBase SummaryCalculator
        {
            get
            {
                if (myCalc == null)
                {
                    this.myCalc = new StandardDeviationCalc();
                }
                return this.myCalc;
            }
        }
    }

    public class AverrageTextCalc : SynchronousSummaryCalculator
    {
        public override SummaryExecution? SummaryExecution
        {
            get
            {
                return Infragistics.SummaryExecution.PriorToFilteringAndPaging;
            }
        }

        public override object Summarize(IQueryable data, string fieldKey)
        {
            return "";
        }
    }

    public class AverrageTextOperand : SummaryOperandBase
    {
        AverrageTextCalc myCalc;

        protected override string DefaultRowDisplayLabel
        {
            get { return "Average"; }
        }

        protected override string DefaultSelectionDisplayLabel
        {
            get { return null; }
        }

        public override SummaryCalculatorBase SummaryCalculator
        {
            get
            {
                return new AverrageTextCalc();
            }
        }
    }
}




